<?php
/**
* Custom Properties for Joomla! 1.6.x - 1.7.x
* @package Custom Properties
* @subpackage Content Plugin cptags
* @version 2.0.1
* @revision $Revision: $
* @author Andrea Forghieri
* @copyright (C) 2008-2011 Andrea Forghieri, Solidsystem - http://www.solidsystem.it
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL version 2
*/
defined('_JEXEC') or die('Restricted access');

// Import library dependencies
jimport('joomla.application.plugin.helper');

//TODO remove the ugly hack when Joomla bug 24340 has been fixed 

class plgContentCpTags extends JPlugin {

	/**
	* Content Item ID
	*
	* @var integer
	*/
	var $_cid;
	/**
	* Content Element
	*
	* @var object
	*/
	var $_ce;

	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		JPlugin::loadLanguage( 'com_customproperties', JPATH_SITE);
	}

	public function onContentPrepare($context, &$row, &$params, $page = 0){

		if(!isset($row->id)){
			return true;	
		}
		else{
			$this->_addCpTags($row, true);
		}
		return true;
	}	
	
	/**
	* Plugin method with the same name as the event will be called automatically.
	*/
	function onContentBeforeDisplay($context, &$row, &$params, $page = 0) {

		if(isset($row->dontProcessMeAgain)) return;
		
		$this->_addCpTags($row, false);

	}

	// update content id for those cptags with cid = 0 (tags applied before saving)
	function onContentAfterSave( $context, &$article, $isNew ) {
	    // We only commit article if this is a new article. Otherwise our work is already done.

		if ($isNew) {
			$db   = &JFactory::getDBO();
			$user = &JFactory::getUser();

			$content_id = mysql_escape_string($article->id);

			$query = "UPDATE #__custom_properties " .
					"SET content_id = '$content_id' " .
					"WHERE content_id = '0' ";
			$db->setQuery($query);

			if (!$db->query()) {
				$this->fatalError('Error updating CP Tags: '.$db->getErrorMsg());
				return false;
			}

		}

		return true;
	}

	/**
	* Replaces the matched {cptags} with the tags
	* @param array An array of matches (see preg_match_all)
	* @param boolean cptags have to be appended to fulltext ? default: false, text appended to introext
	* @return string
	*/
	function CpTags_replacer(& $matches) {
		$text = showTags($this->_ce, $this->_cid, $this->params, $this->params->get('tag_in_meta') );
		return $text;

	}
	function _addCpTags(&$row, $appendToFullText=false){
		global $cp_config;
		$params 			= & $this->params;
		if(!isset($row->id)) return ;

		//NOTE: ugly hack to overcome inconistency in J1.6- 1.7 
		$row->dontProcessMeAgain = 1;
		
		if( (JRequest::getVar('view') == 'featured') && ($params->get("tags_on_frontpage") === '0')) return ;

		// make sure component is installed
		$config_file 	= JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_customproperties' . DS . 'cp_config.php';
		$helper_file 	= JPATH_ROOT . DS . 'components' . DS . 'com_customproperties' . DS . 'helper.php';
		$ce_file	 	= JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_customproperties' . DS . 'contentelement.class.php';
		if (!file_exists($config_file) || !file_exists($helper_file) || !file_exists($ce_file)) {
			echo $row->text .= "<span class=\"alert\">Fatal Error: the component <b>com_customproperties</b> is not/badly installed. " . "Get it at <a href=\"http://www.solidsystem.it\">www.solidsystem.it</a></span>";
			return ;
		} else {
			require $config_file;
			require_once $helper_file;
			require_once $ce_file;
		}

		$option	= JRequest::getVar('option', '');
		$view 	= JRequest::getVar('view', '');
		$task	= JRequest::getVar('task', '');
		
		// get the content element
		$ces = CpContentElements::getInstance();
		if(!$ce = $ces->getByOption($option)){
			return;
		}
		$this->_ce =& $ce;

		//show tags only in detail view?
		if($params->get("tags_on_detail_only") === '1'){
			if(! ($option === $ce->href_option && ($view === $ce->href_view) || $task === $ce->href_task)) return;
		}

		// parameter
		$tags_position		= $params->def('tags_position', '0');
		$show_tag_name		= $params->def('show_tag_name', $cp_config['show_tag_name']);
		$url_format			= $params->def('url_format',	$cp_config['url_format']);
		$linked_tags		= $params->def('linked_tags', 	$cp_config['linked_tags']);
		$use_item_id		= $params->def('use_itemid', 	$cp_config['use_itemid']);

		if($cp_config['use_cp_css']){
			$document = JFactory::getDocument();
			$document->addStyleSheet('components/com_customproperties/css/customproperties.css');
		};

		$frontent_tagging	= $params->def('frontend_tagging', 	$cp_config['frontend_tagging']);
		$editing_level		= $params->def('editing_level', 	$cp_config['editing_level']);

		//append tag to meta only when in "detail / article" view
		if($view === $ce->href_view || $task === $ce->href_task)  {
			$tag_in_meta 	= $params->def('tag_in_meta', 	'1') ;
		}else{
			$tag_in_meta 	= $params->set('tag_in_meta', 	'0') ;
		}

		// saving item id for replacer
		$this->_cid = $cid = $row->id;
		
		if($appendToFullText){
			$textField = 'text';
		}
		else{
			$textField = 'introtext';
		}
		$tags_position = 1;
		switch ($tags_position) {
			case 0 : // bottom
				$row->$textField .= showTags($ce, $cid, $params, $tag_in_meta) ;
				break;
			case 1 : // top
				$row->$textField = showTags($ce, $cid, $params, $tag_in_meta) . $row->$textField;
				break;
			case 2 : // custom
				if (strpos($row->$textField, 'cptags') === false) {
					return ;
				}
				// expression to search for
				$regex = '/{cptags}/i';
				// find all instances of {cptags} and put in $matches
				preg_match_all($regex, $row->$textField, $matches);
				$count = count($matches[0]);
				if ($count) {
					$row->$textField = preg_replace_callback($regex, array (
						'plgContentCpTags',
						'CpTags_replacer'
					), $row->$textField);
					echo "cptags replaced!";
				}
				break;
				//TODO Note: there's a problem if there's no {cptags} and fe_tagging is set, we don't print the Edit Tag
		}
		if(!$appendToFullText){
			$row->text = $row->introtext;
		}
		
	}

}